#!/bin/bash

### CONFIG ###
targetdir="snapshot"
##############

_pwd=`pwd`

function die {
	echo "Error: ${1}"
	exit 1
}

IFS=$'\n'

_ifndef=0
_ifdef=0
_else=0

mkdir ${targetdir} > /dev/null 2>&1
ls ${targetdir} > /dev/null 2>&1
if [ "$?" != "0" ]; then
	die "mkdir ${targetdir} failed!"
fi

mkdir ${targetdir}/asterisk > /dev/null 2>&1
mkdir ${targetdir}/asterisk/channels > /dev/null 2>&1
mkdir ${targetdir}/asterisk/channels/misdn > /dev/null 2>&1
mkdir ${targetdir}/asterisk/configs > /dev/null 2>&1
mkdir ${targetdir}/asterisk/configs/samples > /dev/null 2>&1
mkdir ${targetdir}/asterisk/doc > /dev/null 2>&1


echo -n "Copying files to \"${targetdir}/asterisk/channels/\"... "
cp Makefile.ast ${targetdir}/asterisk/channels/Makefile > /dev/null 2>&1
cp chan_misdn.c chan_misdn_config.c ${targetdir}/asterisk/channels/ > /dev/null 2>&1
if [ "$?" != "0" ]; then
	die "failed"
else
	echo "done"
fi

echo -n "Copying files to \"${targetdir}/asterisk/channels/misdn/\"... "
cp misdn/Makefile.ast ${targetdir}/asterisk/channels/misdn/Makefile > /dev/null 2>&1
cp misdn/isdn*c misdn/isdn*h misdn/portinfo.c misdn/ie*c misdn/chan_misdn_config.h ${targetdir}/asterisk/channels/misdn/ > /dev/null 2>&1
if [ "$?" != "0" ]; then
	die "failed"
else
	echo "done"
fi

echo -n "Copying README to \"${targetdir}/asterisk/doc/README.misdn\"... "
cp README.misdn ${targetdir}/asterisk/doc/README.misdn > /dev/null 2>&1
if [ "$?" != "0" ]; then
	die "failed"
else
	echo "done"
fi

echo -n "Copying misdn.conf to \"${targetdir}/asterisk/configs/misdn.conf.sample\"... "
cp misdn.conf ${targetdir}/asterisk/configs/misdn.conf.sample > /dev/null 2>&1
if [ "$?" != "0" ]; then
	die "failed"
else
	echo "done"
fi

cd ${targetdir}/asterisk/channels || die "cd failed"
filelist1=`ls -1 *.c`
cd misdn || die "cd failed"
filelist2=`ls -1 *.c *.h`

set -o noglob


function remove_stable {
    sed -e '/#ifdef ASTERISK_STABLE/,/#endif/{/#ifdef ASTERISK_STABLE/,/#else/d;/#ifdef ASTERISK_STABLE/d;/#else/d;/#endif/d}; /#ifndef ASTERISK_STABLE/,/#endif/{/#ifndef ASTERISK_STABLE/d; /#else/,/#endif/d;/#endif/d}' $1
}



i=2
while [ ${i} != 0 ]; do

	if [ ${i} == 2 ]; then
		filelist=${filelist2}
		i=1
	else
		cd ..
		filelist=${filelist1}
		i=0
	fi

	for filename in ${filelist};
	do
		echo -n "Now working on \"${filename}\"... "

		RESULTFILE=`tempfile` || die "could not create tempfile"

		remove_stable ${filename} > ${RESULTFILE}
		
		cp -f ${RESULTFILE} ${filename} || die "copy failed"
		rm ${RESULTFILE} || die "could not rm tempfile"

		echo "done"	
	done

done

cd ${_pwd}
